/*
  Designed by LinJiangHua(xempo) 2003-2006
  Copyright 2004-2006 Linjianghua(xempo).
  All Rights Reserve.
*/

#include <dos.h>
#include <time.h>
#include <io.h>
#include "normlib.def"
#include "xbin.def"
#define BSlen   27
#define Btaglen 15
char Verchs[]=" V", **BinDat, 
xbiver[]="eXecuting Binary kern 1.59", Extxbi[]=".xbi",
xbifstruc[28]={'e','X','e','c','u','t','i','n','g',32,'B','i','n','a','r','y',32,
'V','0','0','0','0',13,26};
int xbinMsg; /* all kind of msg for NumbScan, include creatdir msg,
 >0x7ffe is success, other is (err)msg index */
char ScanBuf[32],
xbifVer[dir_style_cnt][5]={ "V1.0", "V1.2" },
__ver[dir_style_cnt][3]={ 0,18,55, 1,24,60 };

void __write(XBIN *xbi,void *dat,size_t datlen,long pos)
{
fseek(xbi->fpt,pos,0);
fwrite(dat,datlen,1,xbi->fpt);
}

unshort __read(XBIN *xbi,void *dat,unshort len, unshort cnt,long pos)
{
fseek(xbi->fpt,pos,0);
return fread(dat,len,cnt,xbi->fpt);
}

unsigned long CurDate()
{
 unsigned long rt;
 unsigned short tim1;
 struct time tm1;
 struct date dt;
 gettime(&tm1); getdate(&dt);
 tim1=(tm1.ti_hour<<11)|(tm1.ti_min<<5)|(tm1.ti_sec>>1);
  rt=(dt.da_year-2004<<9)|(dt.da_mon<<5)|dt.da_day;/* year only begin 2004 */
/*  rt<<=16; */
 return (rt<<16)|tim1;
}

void GetXbiVer(char *chs,char *buf,char *fnd)
{
  char *pt=strstr(chs,fnd);
  if(pt){ 
    char *ptr=strchr(pt,'\r');
    if(ptr)*ptr=0;
    strcpy(buf,pt+1);
  }
}

void ChgFlgs(XBIN *xbi,XBinDir *Dir,int cnt,int xbimsg,int dirmsg)
{
xbi->mdf|=xbimsg;	Dir->mdf|=dirmsg;
if(cnt){ xbi->cn+=cnt;	Dir->cn+=cnt; }
}

void CreatSeg(XBIN *pblk,XBinDir *Dir)
{
int len=Dir->MSG*Dir->PreAlloc +4;
void *dat=malloc(len);
memset(dat,0,len);
__write(pblk,dat,len,pblk->fsz);
pblk->fsz+=len;
Dir->sz+=len;
free(dat);
}

void Destory(XBIN *pt)
{
if(pt/*&&pt->fpt*/){
  if(pt->mdf||(pt->cDir&&pt->adr!=pt->cDir->pOwn)){
    pt->adr=pt->cDir->pOwn;
    pt->date=CurDate();
    __write(pt,&pt->DirAdr,pt->xbinSize,BSlen);
	}
if(pt->fname)free(pt->fname);
if(pt->cDir)DirClose(pt,pt->cDir);
fclose(pt->fpt);
free(pt); /* why not at first ?? */
}
}

XBIN *Instance(char *fnam,short brw)
{
int rt, i, errNo=0;
FILE *fp;
char descpt[40],  *oldfnam=fnam;
XBIN *pblk=(XBIN *)malloc(sizeof(XBIN));
memset(pblk,0,sizeof(XBIN));
/*pt=BinDat[0];*/
ropen: fp=PathOpen(fnam,"rb+");
if(fp==NULL){
  if(errNo==1){ free(fnam); fnam=oldfnam; goto _type_;	}
catExt:	if(oldfnam==fnam && memstr(fnam,0,Extxbi,5,0)==NULL){
		fnam=catstr(fnam,Extxbi);
		goto ropen;
		}
ex:	KShowMsg(oldfnam,BinDat[errNo],1);
__ex:	if(fnam!=oldfnam)free(fnam);
	free(pblk);	return NULL;
	}
else {
	fread(descpt,BSlen,1,fp);
	if(memcmp(descpt,xbifstruc,Btaglen)){
		errNo=1;
		if(oldfnam==fnam){ fclose(fp); goto catExt; }
		else _type_: {	int n=atoi(BinDat[15]);
			char **ptrs, *ptr;
			if((ptr=strchrs(BinDat[16],memblkcmp))!=NULL)*ptr=0;
			if(access(BinDat[16],6))goto _Exit_;
			ptrs=GetDscpt(BinDat[16],n);	n/=2;
			for(i=0;i<n;i++)if(memcmp(ptrs[i],descpt,Btaglen)==0){
				popMsg(ptrs[n+i],fnam,0);	brw=1;
				break;
				}
			if(ptrs[1]!=*ptrs)free(*ptrs);
			free(ptrs);
			goto _Exit_;
		}
	}
	GetXbiVer(descpt,pblk->ver,Verchs);

	memcpy(pblk,descpt[24]>46/* '0' */? __ver[0]:descpt+24,3);
	if(pblk->DirSize>DIRSIZE)pblk->DirSize=DIRSIZE;
	rt=fread(&pblk->DirAdr,pblk->xbinSize,1,fp);
	if(rt<1||pblk->cn<0){
	_Exit_:    fclose(fp);
	if(brw)goto __ex; /* no print */
	else goto ex;
	}
}
pblk->fsz=filelength(fileno(fp));
/*rewind(fp);*/
pblk->fpt=fp;

pblk->fname=oldfnam!=fnam? fnam:strdup(oldfnam);
return pblk;
}

long NumbScan(XBIN *xbin,XBinDir *Dir,long numb,long flg)
{
long *plong, rt, seg, pos;
char *segs_buf, *pcell, *pDAU;
unsigned char flags, clen;
int len, i, j, flagpos, len1, len2;
DAU *pdk, *pdk1, *parm_DAU;
if(xbin==NULL/*||xbin->fpt==NULL*/){ xbinMsg=2; return MSG_NO_NUMB; }
if(Dir==NULL){ xbinMsg=6; return MSG_NO_NUMB; }
xbinMsg=0x7fff;
clen=Dir->MSG;	rt=flg;
flagpos=isLimit(clen)? 4:8;
parm_DAU=(DAU *)(ScanBuf+flagpos+1);
seg = flg!=XBIN_LIST? Dir->hdadr:Dir->nx_seg;
if(seg==0){
  if(flg==XBIN_WRITE){
	Dir->hdadr=xbin->fsz;
	CreatSeg(xbin,Dir);
	return Dir->hdadr;
	}
xbinMsg=4;
return MSG_NO_NUMB;
}
len=Dir->PreAlloc*clen+4;
segs_buf=(char *)malloc(len);
plong=(long *)(segs_buf+len-4);
while( seg>0 ){
if(__read(xbin,segs_buf,len,1,seg)<1){ xbinMsg=5; goto ExitScan; }

#ifndef _K_RUNTIME_
if(flg==XBIN_LIST){ Dir->nx_seg=*plong; return (long)segs_buf; }
#endif

for(i=0,j=0; i<Dir->PreAlloc; i++,j+=clen){
   pos=seg + j;
   pcell=segs_buf + j;
   flags=pcell[flagpos];
   switch( flags ){
   case 1 :
	if(numb==*(long *)pcell)switch(flg){
	case XBIN_READ :
	case XBIN_WRITE : if(flg==XBIN_WRITE)rt=-pos;
	case XBIN_DEL :	/* del need calc size */
		segread: memcpy(ScanBuf,pcell,clen);
		goto outloop;
	default: /* ren numb */ rt=pos; xbinMsg=0x7ffe;
	}/* sw */
	if(flg==*(long *)pcell){ xbinMsg=12;	goto ExitScan;	}
	break;
   case 0 : if(rt<0&&flg==XBIN_WRITE)rt= pos;/* flg=0; only init */
		break;
   default : switch(flg){
	  case XBIN_WRITE :
	  if(isDate(clen)&&CurDate()-*(unsigned long *)(pcell+4)<0xffff)break;
	  pDAU=pcell+clen;	len2=-1;
	  if(clen>sg_dat){ pdk1=(DAU *)(pDAU-8);
	Retry:	len2=pdk1->len-parm_DAU[1].mlen;
		}
	  pdk=(DAU *)(pDAU-8);
	  len1=pdk->len-parm_DAU->mlen;
	  if(rt<0 && flags!=Dir->flg){
	    if( (len1>0&&len1<2048 || len2>0&&len2<2048) || (
		pdk->len<1024&&(clen<=sg_dat||pdk1->len<1024)) ){
		    memcpy(ScanBuf,pcell,clen);
		    *(long *)ScanBuf=numb;
		    rt=pos;
		    }
	    else if(clen>sg_dat){
		DAU dau=*pdk;
		*pdk=*pdk1; *pdk1=dau;
		goto Retry;
			}
	  }
		break;
#ifndef _K_RUNTIME_
	  case XBIN_UNDO : if(flags==Dir->flg)goto intoRescu;
		break;
	  case XBIN_RESCU :
	    if(flags!=Dir->flg){
		intoRescu: rt=pos+flagpos;
		goto segread;
		}
#endif
	  }/* sw */	/* follow is flags=0 */
	}
   }
seg=*plong;
}
/* here must end, Callers process self-data */
outloop:switch(flg){
	case XBIN_READ:
	if(i>=Dir->PreAlloc)xbinMsg=4;
	break;
	case XBIN_DEL:
	if(i<Dir->PreAlloc)rt=pos+flagpos;
	else xbinMsg=4;
	break;
	case XBIN_WRITE :
	if( /*i>=Dir->PreAlloc &&*/ rt==XBIN_WRITE ){
		rt=xbin->fsz;
		__write(xbin,&rt,4,pos+clen);
		CreatSeg(xbin,Dir);
		}
	}
ExitScan: free(segs_buf);
return rt;/* stat-pos ... */
}

void calcLen(MAU *pdat)
{
if(pdat->buf==NULL)pdat->len=0;
else if(pdat->len==0)pdat->len=strlen(pdat->buf);
if(pdat->len>0xfff0)pdat->len=0xfff0;
}

void GetDAU(XBIN *xbin, DAU *dau, MAU *send)
{
if(send){
size_t cn;
char *sendbuf, *oldbuf;
calcLen(send);       oldbuf=send->buf;
send->buf=(char *)malloc( dau->mlen + send->len + 2 );
sendbuf=send->len>0? (char *)malloc( dau->mlen + 2 ):send->buf;

cn=__read(xbin,sendbuf,1,dau->mlen,dau->adr);
if(cn<dau->mlen)popMsg(BinDat[3],sendbuf,1|STYLE);

if(send->len>0){
	if( strchr(sendbuf,'%') )sprintf(send->buf,sendbuf,oldbuf);
	send->len=strlen(send->buf); /* return to user */
	free(sendbuf);
	}
else {
	send->len=cn; /* return to user */
	send->buf[cn]=0;           /* this time buf point to change */
	}
}
}

char *GetNumb(XBIN *xbin,XBinDir *Dir,long nmb,MAU *send1,MAU *send2,int qfg)
/*str1,2 use to format "%s"; return: 0 is fail,other is success */
/* send1.len is add lenght */
{
NumbScan(xbin,Dir,nmb,XBIN_READ);
if(xbinMsg>0x7ffd){
char *	pt=ScanBuf+Dir->MSG;
	if(Dir->MSG>sg_dat){
		pt-=8;
		GetDAU(xbin,(DAU *)pt,send2);
	}
	GetDAU(xbin,(DAU *)(pt-8),send1);
	return ScanBuf;
	}
else {
	char errbuf[20];
	sprintf(errbuf,"%ld",nmb);
	if(qfg)popMsg(BinDat[xbinMsg],errbuf,1|STYLE);
	return NULL;
}
}

void SetDAU(XBIN *xbi,XBinDir *Dir,char flg,DAU *dau,MAU *wtdat)
{
if(wtdat&&wtdat->buf){
  int wtLen=wtdat->len;
  if(flg==1)/* overwrite */ Dir->sz-=dau->mlen;
  if(dau->len<wtLen){
/*  if(flg)pushwas(xbi,dau); create waste space  */
	dau->adr=xbi->fsz;
	xbi->fsz += wtLen;
	dau->len=wtLen;
  }
  dau->mlen=wtLen;/* set current len */
  Dir->sz+=wtLen;/*!! sz is Dir data's size,not disksize, defferenct fsz */
  __write(xbi,wtdat->buf,wtLen,dau->adr);
  }
}

void WriteStat(XBIN *xbin, XBinDir *Dir, char *dat, long pos)
{
if isLimit(Dir->MSG)dat[4]=1;
else { dat[8]=1; *(long *)(dat+4)=CurDate(); }
__write(xbin,dat,Dir->MSG,pos);
}

char *SetNumb(XBIN *xbin,XBinDir *Dir,long nmb,MAU *pdat,MAU *ptdat,int qfg)
{
long pos;
int clen=Dir->MSG;
char *pt;
DAU *pdk0, *pdk1;
if(nmb<=MSG_NO_NUMB){
	xbinMsg=4;
	ExitPrg: popMsg(BinDat[xbinMsg],NULL,1|STYLE);
	return NULL;
	}
pt=ScanBuf+clen;
if(clen>sg_dat){ pt-=8; pdk1=(DAU *)pt; }
pdk0=(DAU *)(pt-8);
memset(ScanBuf,0,clen);/* 2 adr must set 0 */

calcLen(pdat); pdk0->mlen=pdat->len;
if(clen>sg_dat){
	calcLen(ptdat); pdk1->mlen=ptdat->len;
}
pos=NumbScan(xbin,Dir,nmb,XBIN_WRITE);
if(pos<=MSG_NO_NUMB)goto ExitPrg;
if(pos<0 && (qfg&1) && popMsg(BinDat[14],NULL,128|STYLE)!=XbiYES)return NULL;
*(long *)ScanBuf=nmb;
SetDAU(xbin,Dir,pos<0? 1:0,pdk0,pdat);
if(clen>sg_dat)SetDAU(xbin,Dir,pos<0? 1:0,pdk1,ptdat);
WriteStat(xbin,Dir,ScanBuf,pos>0? pos:-pos);
ChgFlgs(xbin,Dir,pos>0?1:0,1,1);
return ScanBuf;
}